/*
 * @(#)DndTreeCellRenderer.java   3.1  25 Sep 2000
 *
 */

import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;

/**
 * This class provides a simple implementation of the DefaultTreeCellRenderer.  Here one can add
 * any kind of cell rendering capablities like different color different images etc.
 * The only change from DefaultCellRenderer is stringValue DefaultCellRenderer gets the string reprasentation
 * from the tree this class gets from treemodel.
 *
 * @Author Kesav Kumar Kolla, Ruchi Kolla
 * @Version %I%,%G%
 */
public class TrdTreeCellRenderer extends DefaultTreeCellRenderer
{
	TrdTreeCellRenderer()
	{
		super();
		setClosedIcon(null);
		setOpenIcon(null) ;
	}

	public Component getTreeCellRendererComponent(JTree tree,
							Object value,
							boolean selected,
							boolean expanded,
							boolean leaf,
							int row,
							boolean hasFocus)
	{
		final String stringValue = ((TrdDOMTreeModel)tree.getModel()).convertValueToText(value);
		return super.getTreeCellRendererComponent(tree,
								stringValue,
								selected,
								expanded,
								leaf,
								row,
								hasFocus);
	}
}